Community
cancel
Showing results for 
Search instead for 
Did you mean: 
Simone_Tinti
Beginner
42 Views

mpiicc architecture incompatibility on Xeon Phi x200 KNL

Hello,

i receive the following errors while trying to compile High Performance Linpack for Intel Xeon Phi x200 (KNL), do you have any suggestion?

---------------

mpiicc -o HPL_pdtest.o -c  -DHPL_CALL_CBLAS -I/opt/hpl-2.2/include -I/opt/hpl-2.2/include/KNL_MKL5 -I/opt/intel/compilers_and_libraries/linux/mkl/include/mic/lp64 -I/opt/intel/impi/2017.2.174/mic/include -xHost -fomit-frame-pointer -O3 -funroll-loops -qopenmp  ../HPL_pdtest.c
mpiicc  -DHPL_CALL_CBLAS -I/opt/hpl-2.2/include -I/opt/hpl-2.2/include/KNL_MKL5 -I/opt/intel/compilers_and_libraries/linux/mkl/include/mic/lp64 -I/opt/intel/impi/2017.2.174/mic/include -xHost -fomit-frame-pointer -O3 -funroll-loops -qopenmp -o /opt/hpl-2.2/bin/KNL_MKL5/xhpl HPL_pddriver.o         HPL_pdinfo.o           HPL_pdtest.o /opt/hpl-2.2/lib/KNL_MKL5/libhpl.a  -Wl,--start-group /opt/intel/compilers_and_libraries/linux/mkl/lib/mic/libmkl_intel_lp64.a /opt/intel/compilers_and_libraries/linux/mkl/lib/mic/libmkl_intel_thread.a /opt/intel/compilers_and_libraries/linux/mkl/lib/mic/libmkl_core.a -Wl,--end-group -lpthread -lm /opt/intel/impi/2017.2.174/mic/lib/libmpi_mt.a
ld: k1om architecture of input file `/opt/intel/compilers_and_libraries/linux/mkl/lib/mic/libmkl_intel_lp64.a(cblas_idamax_lp64.o)' is incompatible with i386:x86-64 output
ld: k1om architecture of input file `/opt/intel/compilers_and_libraries/linux/mkl/lib/mic/libmkl_intel_lp64.a(cblas_dtrsv_lp64.o)' is incompatible with i386:x86-64 output
ld: k1om architecture of input file `/opt/intel/compilers_and_libraries/linux/mkl/lib/mic/libmkl_intel_lp64.a(cblas_dtrsm_lp64.o)' is incompatible with i386:x86-64 output
ld: k1om architecture of input file `/opt/intel/compilers_and_libraries/linux/mkl/lib/mic/libmkl_intel_lp64.a(cblas_dscal_lp64.o)' is incompatible with i386:x86-64 output
ld: k1om architecture of input file `/opt/intel/compilers_and_libraries/linux/mkl/lib/mic/libmkl_intel_lp64.a(cblas_dger_lp64.o)' is incompatible with i386:x86-64 output
ld: k1om architecture of input file `/opt/intel/compilers_and_libraries/linux/mkl/lib/mic/libmkl_intel_lp64.a(cblas_dgemv_lp64.o)' is incompatible with i386:x86-64 output
ld: k1om architecture of input file `/opt/intel/compilers_and_libraries/linux/mkl/lib/mic/libmkl_intel_lp64.a(cblas_dgemm_lp64.o)' is incompatible with i386:x86-64 output

---------------

source /opt/intel/impi/2017.2.174/bin64/mpivars.sh
source /opt/intel/bin/iccvars.sh intel64
source /opt/intel/bin/ifortvars.sh intel64
source /opt/intel/compilers_and_libraries_2017.2.174/linux/mkl/bin/mklvars.sh  intel64

---------------

echo $LD_LIBRARY_PATH
/opt/intel/compilers_and_libraries_2017.2.174/linux/compiler/lib/intel64_lin:/opt/intel/compilers_and_libraries_2017.2.174/linux/mkl/lib/intel64_lin:/opt/intel/compilers_and_libraries_2017.2.174/linux/compiler/lib/intel64:/opt/intel/compilers_and_libraries_2017.2.174/linux/compiler/lib/intel64_lin:/opt/intel/compilers_and_libraries_2017.2.174/linux/mpi/intel64/lib:/opt/intel/compilers_and_libraries_2017.2.174/linux/mpi/mic/lib:/opt/intel/compilers_and_libraries_2017.2.174/linux/ipp/lib/intel64:/opt/intel/compilers_and_libraries_2017.2.174/linux/compiler/lib/intel64_lin:/opt/intel/compilers_and_libraries_2017.2.174/linux/mkl/lib/intel64_lin:/opt/intel/compilers_and_libraries_2017.2.174/linux/tbb/lib/intel64/gcc4.7:/opt/intel/debugger_2017/iga/lib:/opt/intel/debugger_2017/libipt/intel64/lib:/opt/intel/compilers_and_libraries_2017.2.174/linux/daal/lib/intel64_lin:/opt/intel/compilers_and_libraries_2017.2.174/linux/compiler/lib/intel64:/opt/intel/compilers_and_libraries_2017.2.174/linux/compiler/lib/intel64_lin:/opt/intel/compilers_and_libraries_2017.2.174/linux/mpi/intel64/lib:/opt/intel/compilers_and_libraries_2017.2.174/linux/mpi/mic/lib:/opt/intel/compilers_and_libraries_2017.2.174/linux/ipp/lib/intel64:/opt/intel/compilers_and_libraries_2017.2.174/linux/compiler/lib/intel64_lin:/opt/intel/compilers_and_libraries_2017.2.174/linux/mkl/lib/intel64_lin:/opt/intel/compilers_and_libraries_2017.2.174/linux/tbb/lib/intel64/gcc4.7:/opt/intel/debugger_2017/iga/lib:/opt/intel/debugger_2017/libipt/intel64/lib:/opt/intel/compilers_and_libraries_2017.2.174/linux/daal/lib/intel64_lin:/opt/intel/compilers_and_libraries_2017.2.174/linux/daal/../tbb/lib/intel64_lin/gcc4.4:/opt/intel/compilers_and_libraries_2017.2.174/linux/mpi/intel64/lib:/opt/intel/compilers_and_libraries_2017.2.174/linux/mpi/mic/lib

---------------

NOTES:

-same errors using different options like -x MIC-AVX512

-from documentation it's not clear to me if for x200 Xeon Phi the  lib and include files  shuold be the ones in /intel64 o /mic subfolders (that anyway seem to be selected automatically (mic version) at compile time  despite of  he LD_LIBRARY_PATH directories order)

---------------

Many thanks for your support

Simone Tinti

 

0 Kudos
2 Replies
TimP
Black Belt
42 Views

No, you must permit the linker to use the intel64 mkl libraries, not the ones which support only knc.

Simone_Tinti
Beginner
42 Views

Many thanks for you support, setting LD_LIBRARY_PATH properly solved this issue.

Simone.

Reply